local SetUsUpTheBomb = Apollo.GetAddon("SetUsUpTheBomb")
local DaiGUI = Apollo.GetPackage("DaiGUI-1.0").tPackage
local ktFormDefinitions


function SetUsUpTheBomb:CreateMainWindow()
  return self:FactoryProduce("MainForm", "FixedHudStratum")
end

function SetUsUpTheBomb:CreateWarningWindow()
  return self:FactoryProduce("WarningForm", "FixedHudStratumHigh")
end

-- Create a list item window
function SetUsUpTheBomb:CreateItemWindow()
  return self:FactoryProduce("ListItem", self.wndItemList)
end

function SetUsUpTheBomb:FactoryProduce(strFormName, wndParent, tObject)
	local wndNew
  
  if wndParent ~= nil and type(wndParent) ~= "string" and tObject ~= nil then
    wndNew = wndParent:FindChildByUserData(tObject)
  end
  
	if not wndNew then
    wndNew = DaiGUI:Create(ktFormDefinitions[strFormName]):GetInstance(self, wndParent)
    wndNew:SetData(tObject)
	end
	return wndNew
end


ktFormDefinitions = {
   WarningForm = {
    AnchorOffsets = { -250, -30, 250, 30 },
    AnchorPoints = "CENTER",
    RelativeToClient = true, 
    Name = "SetUsUpTheBombWarningForm", 
    SwallowMouseClicks = true, 
    Overlapped = true, 
    IgnoreMouse = true, 
    NewWindowDepth = 1, 
    Visible = false,
    Children = {
      {
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "Targeted", 
        Pixies = {
          { AnchorPoints = "FILL", BGColor = "white", TextColor = "aaff0000", Font = "CRB_FloaterGigantic_O", Text = "Explosions Coming!", DT_CENTER = true, DT_VCENTER = true, },
        },
      },
    },
  },
  --
  ListItem = {
    AnchorOffsets = { 0, 0, 0, 18 },
    AnchorPoints = "HFILL",
    RelativeToClient = true, 
    Name = "ListItem", 
    SwallowMouseClicks = true, 
    Children = {
      {
        AnchorOffsets = { 28, -1, -102, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Font = "CRB_Interface10_BO", 
        Text = "", 
        Name = "NameText", 
        DT_VCENTER = true, 
      },
      {
        AnchorOffsets = { 8, -1, -108, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Font = "CRB_Interface9_BO", 
        Text = "", 
        Name = "TpsText", 
        DT_VCENTER = true, 
        DT_RIGHT = true, 
      },
      {
        AnchorOffsets = { 8, -1, -8, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Font = "CRB_Interface9_BO", 
        Text = "", 
        Name = "AmountText", 
        DT_VCENTER = true, 
        DT_RIGHT = true, 
      },
      {
        AnchorOffsets = { 20, 1, 0, 2 },
        AnchorPoints = "FILL",
        Class = "ProgressBar", 
        AutoSetText = false, 
        UseValues = false, 
        RelativeToClient = true, 
        SetTextToProgress = true, 
        DT_CENTER = true, 
        DT_VCENTER = true, 
        ProgressEmpty = "ClientSprites:BlackFill", 
        ProgressFull = "ClientSprites:HoverHealthFull", -- ClientSprites:WhiteFill", 
        Name = "ProgressBar", 
        BarColor = "ffffffff", 
        IgnoreMouse = true, 
        UsePercent = false, 
      },
 	  {
        PosSize = { 1, -1, 20, 20 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "ProgressIcon", 
		Sprite = "Icon_Windows_UI_CRB_Marker_Bomb",
      },

    },
  },


  --
  MainForm = {
    AnchorOffsets = { 4, 4, 404, 196 },
    RelativeToClient = true, 
    Name = "MainForm", 
    SwallowMouseClicks = true, 
    Moveable = true, 
--    Escapable = true, 
    Overlapped = true, 
    Sizable = true, 
    Visible = false,
    Pixies = {
      { AnchorPoints = "FILL", Sprite = "BK3:UI_BK3_Holo_Framing_3", BGColor = "white", TextColor = "black", },
      { AnchorPoints = "BOTTOMRIGHT", AnchorOffsets = {-33, -33, -26, -24}, ResizeHandle=5 },

    },
    Children = {
      {
        AnchorOffsets = { 36, 25, -51, 51 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "DefaultButton", 
        Name = "TitleText", 
        TextColor = "UI_TextHoloTitle", 
        DT_VCENTER = true, 
        NewControlDepth = 2, 
        Text = "Set Us Up The Bomb", 
      },
      {
        AnchorOffsets = { -53, 28, -29, 52 },
        AnchorPoints = "TOPRIGHT",
        Class = "Button", 
        Base = "BK3:btnHolo_Close", 
        Font = "Thick", 
        ButtonType = "PushButton", 
        DT_VCENTER = true, 
        DT_CENTER = true, 
        Name = "CloseButton", 
        NewControlDepth = 2, 
        WindowSoundTemplate = "CloseWindowPhys", 
        Events = {
          ButtonSignal = "OnClose",
        },
      },
      {
        AnchorOffsets = { 31, 51, -33, -32 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "Container", 
        IgnoreMouse = true, 
        Children = {
          {
            AnchorPoints = "FILL",
            RelativeToClient = true, 
            BGColor = "2x:ffffffff", 
            TextColor = "UI_WindowTextDefault", 
            Name = "ContainerArt", 
            IgnoreMouse = true, 
            Sprite = "BK3:sprMetal_Scroll_Framing", 
            NoClip = true, 
            Picture = true, 
            Children = {
              {
                AnchorOffsets = { -142, 2, -1, -1 },
                AnchorPoints = "VFILLRIGHT",
                RelativeToClient = true, 
                BGColor = "UI_WindowBGDefault", 
                TextColor = "UI_WindowTextDefault", 
                Name = "Crack", 
                Sprite = "BK3:UI_BK3_Holo_Framing_Crack", 
                Picture = true, 
                IgnoreMouse = true, 
              },
              {
                AnchorOffsets = { 2, 2, -2, -2 },
                AnchorPoints = "FILL",
                RelativeToClient = true, 
                BGColor = "UI_WindowBGDefault", 
                TextColor = "UI_WindowTextDefault", 
                Name = "Scanlines", 
                Picture = true, 
                IgnoreMouse = true, 
                Sprite = "CRB_Basekit:kitAccent_Scanlines", 
              },
            },
          },
          {
            AnchorOffsets = { 2, 2, -2, -2 },
            AnchorPoints = "FILL",
            RelativeToClient = true, 
            Name = "ItemList", 
--            VScroll = true, 
            IgnoreMouse = true, 
          },
        },
      },
    },
  }
}

